"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveDevOptions = void 0;
const path_1 = __importDefault(require("path"));
const core_1 = require("@rspack/core");
function resolveDevOptions(devConfig, compilerOptions) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    const open = true;
    const hot = (_a = devConfig.hot) !== null && _a !== void 0 ? _a : true;
    // --- static
    const directory = (_c = (_b = devConfig.static) === null || _b === void 0 ? void 0 : _b.directory) !== null && _c !== void 0 ? _c : path_1.default.resolve(compilerOptions.context, "dist");
    let watch = {};
    if (((_d = devConfig.static) === null || _d === void 0 ? void 0 : _d.watch) === false) {
        watch = false;
    }
    else if (((_e = devConfig.static) === null || _e === void 0 ? void 0 : _e.watch) === true) {
        watch = (0, core_1.resolveWatchOption)({});
    }
    else if ((_f = devConfig.static) === null || _f === void 0 ? void 0 : _f.watch) {
        watch = (_g = devConfig.static) === null || _g === void 0 ? void 0 : _g.watch;
    }
    // ---
    const devMiddleware = (_h = devConfig.devMiddleware) !== null && _h !== void 0 ? _h : {};
    const liveReload = (_j = devConfig.liveReload) !== null && _j !== void 0 ? _j : true;
    let webSocketServer = {};
    if (devConfig.webSocketServer === false) {
        webSocketServer = false;
    }
    else if (devConfig.webSocketServer === true) {
        webSocketServer = {};
    }
    else if (devConfig.webSocketServer) {
        webSocketServer = devConfig.webSocketServer;
    }
    return {
        host: devConfig.host,
        port: devConfig.port ? Number(devConfig.port) : undefined,
        static: {
            directory,
            watch
        },
        devMiddleware,
        open,
        hot,
        liveReload,
        webSocketServer
    };
}
exports.resolveDevOptions = resolveDevOptions;
//# sourceMappingURL=config.js.map